package qr;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.DisplayMode;
import java.awt.Frame;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Image;
import java.util.Enumeration;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;

import processing.core.PApplet;

public class Screen {

	public static Frame fullFrame;
	public static JFrame frame;
	public static int textAreaWidth;
	
	private static Vector screenListener = new Vector();

	public static boolean TITLE_IMAGE = true;
	public static boolean FULL_SCREEN = false;
	
//	public static int H = screenSize[1];
//	public static int W = screenSize[0];
//	public static int FULL_SCREEN_WIDTH = 1024;
//	public static int FULL_SCREEN_HEIGHT = 768;
//	public static float reductionRatio = SCREEN_WIDTH / 1280f;
//	public static float RA = reductionRatio; 	// wb_摜pɔ{̌vZ
//	public static int W = SCREEN_WIDTH;
//	public static int H = (int) (SCREEN_HEIGHT - (90 * 2 * reductionRatio));
	public final static int DEFAULT_SCREEN_WIDTH = 1024;
	public final static int DEFAULT_SCREEN_HEIGHT = 768;
	public static int[] screenSize = {DEFAULT_SCREEN_WIDTH, DEFAULT_SCREEN_HEIGHT};
	public static int QR_HEIGHT = screenSize[1]/2;

	private static final int defaultLargeFontSize = (int)(screenSize[0]*0.045);
	private static final int defaultMiddleFontSize = (int)(screenSize[0]*0.030);
	private static final int defaultSmallFontSize = (int)(screenSize[0]*0.015);

	public static int textDefaultX = 40;
	public static int textDefaultY = 60;
	static Image qrImage;
	public static JLabel qrLabel;

	private static int largeFontSize = defaultLargeFontSize;
	private static int largeFontLineMargin = (int)(largeFontSize * 1.2);
	
	private static int middleFontSize = defaultMiddleFontSize;
	private static int middleFontLineMargin = (int)(middleFontSize * 1.2);
	
	private static int smallFontSize = defaultSmallFontSize;
	private static int smallFontLineMargin = (int)(smallFontSize * 1.2);
	
	/**
	 * @param size Largew̃tHgTCY
	 */
	public static void setLargeFontSize(int size) {
		largeFontSize = size;
		largeFontLineMargin = (int)(largeFontSize * 1.2);	// ̍sւY}[W
	}
	
//	/**
//	 * @return Largew̃tHgTCY
//	 */
//	public static int getLargeFontSize() {
//		return largeFontSize;
//	}
//	
//	/**
//	 * @return LargetHg̍s
//	 */
//	public static int getLargeFontLineMargin() {
//		return largeFontLineMargin;
//	}
	
	/**
	 * @param size Middlew̃tHgTCY
	 */
	public static void setMiddleFontSize(int size) {
		middleFontSize = size;
		middleFontLineMargin = (int)(largeFontSize * 1.2);	// ̍sւY}[W
	}
	
//	/**
//	 * @return Middlew̃tHgTCY
//	 */
//	public static int getMiddleFontSize() {
//		return middleFontSize;
//	}
//	
//	/**
//	 * @return MiddletHg̍s
//	 */
//	public static int getMiddleFontLineMargin() {
//		return middleFontLineMargin;
//	}

	/**
	 * @param size Smallw̃tHgTCY
	 */
	public static void setSmallFontSize(int size) {
		smallFontSize = size;
		smallFontLineMargin = (int)(largeFontSize * 1.2);	// ̍sւY}[W
	}
	
//	/**
//	 * @return Smallw̃tHgTCY
//	 */
//	public static int getSmallFontSize() {
//		return smallFontSize;
//	}
//	
//	/**
//	 * @return SmalltHg̍s
//	 */
//	public static int getSmallFontLineMargin() {
//		return smallFontLineMargin;
//	}
	
	
//	/**
//	 * @param b
//	 * resize()ĂяoŃtXN[ɂ邩ǂݒ
//	 */
//	public static void setFullScreen(boolean b) {
//		FULL_SCREEN = b;
//	}
	
	/**
	 * @param id
	 * XN[TCYԍŎw
	 */
	public static void setScreenSize(int id) {
		screenSize = SCREEN_SIZE[id];
		QR_HEIGHT = screenSize[1]/2;
	}

	/**
	 * @param x
	 * @param y
	 * XN[TCYlŎw
	 */
	public static void setScreenSize(int x, int y) {
		screenSize[0] = x;
		screenSize[1] = y;
	}
	
	/**
	 * @return
	 */
	public static int getWidth() {
		return screenSize[0];
	}
	
	/**
	 * @return
	 */
	public static int getHeight() {
		return screenSize[1];
	}

	/**
	 * <code>SCREEN_SIZE</code> ftHg̃XN[TCY
	 */
	public static int[][] SCREEN_SIZE = {
		{640, 480},
		{800, 600},
		{1024, 768},
		{1280, 1024},
	};
	
	/*
	 * \ȃtXN[TCYi@ˑƂ肠X^_[h4̗pj
	 */
	private static int[][] FULL_SCREEN_SIZE = {
		{640, 480},
		{800, 600},
		{1024, 768},
		{1280, 1024},
		{1400, 1050},
	};
	
	public static void showGUI(){
		Qr.gui.setVisible(true);
	}
	/**
	 * 
	 */
	public static void removeApplet(){
		frame.remove(Qr.applet);
	}


	
	/**
	 * eϐ̍ĐݒB
	 * XN[TCY̕ύXŌĂяoB
	 */
	private static void resetParam() {
		textDefaultX = (int)(screenSize[0] * 0.05);
		textDefaultY = (int)(screenSize[1] * 0.1);
		textAreaWidth = screenSize[0] - textDefaultX * 2;

		largeFontSize = (int)(screenSize[0]*0.045);
		middleFontSize = (int)(screenSize[0]*0.030);
		smallFontSize = (int)(screenSize[0]*0.015);
		
		largeFontLineMargin = (int)(largeFontSize * 1.2);
		middleFontLineMargin = (int)(middleFontSize * 1.2);
		smallFontLineMargin = (int)(smallFontSize * 1.2);
		refreshParam();
	}
	
	public static void refreshParam() {
		for(Enumeration e = screenListener.elements(); e.hasMoreElements(); ) {
			ScreenChangeListener scl = (ScreenChangeListener) e.nextElement();
			scl.screenSizeChanged(screenSize[0], screenSize[1]);
			scl.textAreaChanged(textDefaultX, textDefaultY, textAreaWidth);
			scl.fontSizeChanged(largeFontSize, middleFontSize, smallFontSize);
			scl.fontMarginChanged(largeFontLineMargin, middleFontLineMargin, smallFontLineMargin);
		}
	}

//	public static int HEADER_HEIGHT = 70;

//	public static void setScreenSize(){
//		resetParam();
//		int width = screenSize[0];
//		int height = screenSize[1];
//		frame.setVisible(false);
//		frame.getContentPane().remove(Code.applet);
//		Code.applet.setSize(width, height);
//		frame.getContentPane().add(Code.applet);
//
//		GraphicsDevice gd = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice();
//		DisplayMode mode = gd.getDisplayMode();
//		int localeX = mode.getWidth() / 2 - width / 2;
//		int localeY = mode.getHeight() / 2 - height / 2;
//		frame.setBounds(localeX, localeY, width, height);
////		frame.pack();
//		frame.setVisible(true);
//	}
	

	public static void initScreen() {
		PApplet applet = Qr.applet;
		PApplet applet2 = Qr.applet2;
		
		resetParam();
		applet.setSize(screenSize[0], QR_HEIGHT);
		applet2.setSize(screenSize[0], QR_HEIGHT);
		
		frame = new JFrame("Qr ver1.0");
		frame.getContentPane().setLayout(new BorderLayout());
		
		GraphicsDevice gd = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice();
		DisplayMode mode = gd.getDisplayMode();
		int localeX = mode.getWidth() / 2 - screenSize[0] / 2;
		int localeY = mode.getHeight() / 2 - screenSize[1] / 2;
//			qrImage = ImageIO.read(new File("./img/qr0.gif"));
//			qrImage = qrImage.getScaledInstance(QR_HEIGHT, QR_HEIGHT, Image.SCALE_SMOOTH);
//			
//			ImageIcon icon = new ImageIcon(qrImage);
//			qrLabel = new JLabel(icon);
//			qrLabel.setSize(icon.getIconWidth(), icon.getIconHeight());
//			qrLabel.setLocation((int)(DEFAULT_SCREEN_WIDTH * 0.5f - QR_HEIGHT * 0.5f), 0);
//			
		ImageIcon icon = new ImageIcon("img/qricon.gif");
		frame.setIconImage(icon.getImage());
		frame.getContentPane().add(applet2, BorderLayout.NORTH);
		frame.getContentPane().add(applet, BorderLayout.CENTER);
		frame.getContentPane().setBackground(Color.WHITE);
		frame.setBounds(localeX, localeY, screenSize[0], screenSize[1]);
		frame.pack();
//		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
//		frame.setResizable(false);
//			frame.setAlwaysOnTop(true);		// ɎOɕ\
//			applet.requestFocus();
//			frame.requestFocusInWindow();
//		qrImage.flush();
		resizeScreen();
	}
	
	public static void resizeScreen(){
//		frame.setResizable(true);
		resetParam();
		int width = screenSize[0];
		int height = QR_HEIGHT;
		frame.setVisible(false);
		frame.getContentPane().remove(Qr.applet);
		frame.getContentPane().remove(Qr.applet2);
		Qr.applet.setSize(width, height);
		Qr.applet.size(width, height);
		Qr.applet2.setSize(width, height);
		Qr.applet2.size(width, height);
		frame.getContentPane().add(Qr.applet2, BorderLayout.NORTH);
		frame.getContentPane().add(Qr.applet, BorderLayout.CENTER);
		frame.getContentPane().setBackground(Color.WHITE);

		GraphicsDevice gd = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice();
		DisplayMode mode = gd.getDisplayMode();
		int localeX = mode.getWidth() / 2 - width / 2;
		int localeY = mode.getHeight() / 2 - height;
		frame.setBounds(localeX, localeY, width, height+30);
		frame.pack();
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
//		frame.setResizable(false);
		Qr.applet.reloadFont();
		Qr.applet2.reloadFont();
		Qr.applet.reloadFront();
	}
	
//	public static void changeQR(int i){
//		try {
//			qrImage = ImageIO.read(new File("./img/qr" + i + ".gif"));
//			qrImage = qrImage.getScaledInstance(QR_HEIGHT, QR_HEIGHT, Image.SCALE_SMOOTH);
//			System.out.println("./img/qr" + i + ".gif");
//			
//			frame.getContentPane().remove(qrLabel);
//			ImageIcon icon = new ImageIcon(qrImage);
//			qrLabel = new JLabel(icon);
//			qrLabel.setSize(icon.getIconWidth(), icon.getIconHeight());
//			qrLabel.setLocation((int)(DEFAULT_SCREEN_WIDTH * 0.5f - QR_HEIGHT * 0.5f), 0);
//			
//			frame.getContentPane().add(qrLabel, BorderLayout.NORTH);
//			frame.getContentPane().repaint();
//			qrImage.flush();
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//	}
	
	public static void fullScreen() {
		if(FULL_SCREEN) {
			fullScreenOff();
		} else {
//			Code.showGUI();
			fullScreenOn();
		}
		FULL_SCREEN = !FULL_SCREEN;
	}
	
	public static void fullScreenOff() {
		if(fullFrame != null) {
			fullFrame.remove(Qr.applet);
			fullFrame.remove(Qr.applet2);
			fullFrame = null;
		}
		resizeScreen();
	}
	
	public static void fullScreenOn() {
		fullFrame = new Frame();
		fullFrame.setLayout(null);
		fullFrame.setUndecorated(true);
		fullFrame.setBackground(Color.BLACK);
		fullFrame.setAlwaysOnTop(true);
		//		resetParam();
		PApplet applet = Qr.applet;
		PApplet applet2 = Qr.applet2;
//		frame.dispose();
		frame.getContentPane().remove(applet);
		frame.getContentPane().remove(applet2);
		GraphicsDevice gd = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice();

		int fullScreenId = 0;
		int fullx = 0, fully = 0; 

		do {
			fullx = FULL_SCREEN_SIZE[fullScreenId][0];
			fully = FULL_SCREEN_SIZE[fullScreenId][1];
			fullScreenId++;
			if(fullScreenId >= FULL_SCREEN_SIZE.length) {
				System.out.println("XN[TCY傫");
				return;
			}
		}while(screenSize[0] > fullx || QR_HEIGHT > fully);
		
		int w = (fullx - screenSize[0]) / 2;
		int h = (fully - screenSize[1]) / 2;
//		System.out.println(w + " "+ h);
		applet2.setLocation(w, h);
		applet.setLocation(w, h + QR_HEIGHT);
		
		if (gd.isFullScreenSupported()) {
			gd.setFullScreenWindow(fullFrame);
		}
		if (gd.isDisplayChangeSupported()) {
			gd.setDisplayMode(new DisplayMode(fullx, fully, 32, 0));
		}
		JLabel label = new JLabel();
		label.setOpaque(true);
		label.setBackground(Color.BLACK);
		label.setLocation(0, 0);
		fullFrame.add(applet2);
		fullFrame.add(applet);
		Qr.applet.reloadFont();
		Qr.applet2.reloadFont();
		fullFrame.setVisible(true);
		applet.requestFocus();
	}

	public static void addScreenListener(ScreenChangeListener scl) {
		screenListener.addElement(scl);
		scl.screenSizeChanged(screenSize[0], QR_HEIGHT);
		scl.textAreaChanged(textDefaultX, textDefaultY, textAreaWidth);
		scl.fontSizeChanged(largeFontSize, middleFontSize, smallFontSize);
		scl.fontMarginChanged(largeFontLineMargin, middleFontLineMargin, smallFontLineMargin);
	}
	
//	public static void resize(){
//		resetParam();
//		PApplet applet = Code.applet;
//		GraphicsDevice gd = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice();
//
////		applet.setSize(screenSize[0], screenSize[1]);
//		frame = new Frame("Code ver2.0");
//		frame.setLayout(null);
//		
//		if(FULL_SCREEN){
//			// ݂screenSizeK؂ȉ𑜓x
//			int fullScreenId = 0;
//			int fullx = 0, fully = 0; 
//			frame.setUndecorated(true);
//			
//			do {
//				fullx = FULL_SCREEN_SIZE[fullScreenId][0];
//				fully = FULL_SCREEN_SIZE[fullScreenId][1];
//				fullScreenId++;
//				if(fullScreenId >= FULL_SCREEN_SIZE.length) {
//					System.out.println("XN[TCY傫");
//					return;
//				}
//			}while(screenSize[0] > fullx || screenSize[1] > fully);
//			
//			int w = (fullx - screenSize[0]) / 2;
//			int h = (fully - screenSize[1]) / 2;
////			System.out.println(w + " "+ h);
//			applet.setLocation(w, h);
//
//			if (gd.isFullScreenSupported()) {
//				gd.setFullScreenWindow(frame);
//			}
//			if (gd.isDisplayChangeSupported()) {
//				gd.setDisplayMode(new DisplayMode(fullx, fully, 32, 0));
//			}
//			frame.setBackground(Color.BLACK);
//			frame.add(applet);
//			frame.setVisible(true);
//			
//		}else{
//			
//			DisplayMode mode = gd.getDisplayMode();
////			applet.setLocation(0, 40);
//			int localeX = mode.getWidth() / 2 - screenSize[0] / 2;
//			int localeY = 0;//mode.getHeight() / 2 - H / 2;
//			frame.add(applet);
//			frame.setBounds(localeX, localeY, screenSize[0], screenSize[1]+40);
//			frame.setBackground(Color.BLACK);
//			frame.setVisible(true);
//		}
//
//		System.out.println(
//				"reset Screen Size\n"+
//				"x : "+screenSize[0]+"    y : "+screenSize[1]+"\n"
//		);
//		
//		applet.requestFocus();
//		
//		
//		frame.addWindowListener(new WindowAdapter() {
//			public void windowClosing(WindowEvent e) {
//				// OpenGLgĂƕʂɗƂƂ܂Ȃ
//				System.out.println("System down");
//				Synth.stop();
//				Synth.stopEngine();
//				System.exit(1);
//			}
//		});
//	}
	
//	public static void resize(){
//		PApplet applet = Code.applet;
//		GraphicsDevice gd = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice();
//
//		resetParam();
//		
////		applet.setSize(screenSize[0], screenSize[1]);
//		
//		if(FULL_SCREEN){
//			frame = new Frame("Code ver2.0");
//			frame.setLayout(null);
//			// ݂screenSizeK؂ȉ𑜓x
//			int fullScreenId = 0;
//			int fullx = 0, fully = 0; 
//			frame.setUndecorated(true);
//			
//			do {
//				fullx = FULL_SCREEN_SIZE[fullScreenId][0];
//				fully = FULL_SCREEN_SIZE[fullScreenId][1];
//				fullScreenId++;
//				if(fullScreenId >= FULL_SCREEN_SIZE.length) {
//					System.out.println("XN[TCY傫");
//					return;
//				}
//			}while(screenSize[0] > fullx || screenSize[1] > fully);
//			
//			int w = (fullx - screenSize[0]) / 2;
//			int h = (fully - screenSize[1]) / 2;
////			System.out.println(w + " "+ h);
//			applet.setLocation(w, h);
//
//			if (gd.isFullScreenSupported()) {
//				gd.setFullScreenWindow(frame);
//			}
//			if (gd.isDisplayChangeSupported()) {
//				gd.setDisplayMode(new DisplayMode(fullx, fully, 32, 0));
//			}
//			frame.setBackground(Color.BLACK);
//			frame.add(applet);
//			frame.setVisible(true);
//			
//		}else{
//			frame = new JFrame("Code ver2.0");
//			
//			DisplayMode mode = gd.getDisplayMode();
////			applet.setLocation(0, 40);
//			int localeX = mode.getWidth() / 2 - screenSize[0] / 2;
//			int localeY = 0;//mode.getHeight() / 2 - H / 2;
//			frame.setBounds(localeX, localeY, screenSize[0], screenSize[1]+40);
//			frame.setBackground(Color.BLACK);
//			((JFrame) frame).getContentPane().add(applet);
//			frame.pack();
//			frame.setVisible(true);
//		}
//
//		System.out.println(
//				"reset Screen Size\n"+
//				"x : "+screenSize[0]+"    y : "+screenSize[1]+"\n"
//		);
//		
//		applet.requestFocus();
//		
//		
//		frame.addWindowListener(new WindowAdapter() {
//			public void windowClosing(WindowEvent e) {
//				// OpenGLgĂƕʂɗƂƂ܂Ȃ
//				System.out.println("System down");
//				Synth.stop();
//				Synth.stopEngine();
//				System.exit(1);
//			}
//		});
//	}

		
	
//	public static void setScreen(){
//		PApplet applet = Code.applet;
//		int size[] = SCREEN_SIZE[1];
//		
//		try {
//			SCREEN_WIDTH = size[0];
//			SCREEN_HEIGHT = size[1];
//			
//			if(SCREEN_WIDTH > 1024) {
//				FULL_SCREEN_WIDTH = 1280;
//				FULL_SCREEN_HEIGHT = 1024;
//			} else if(SCREEN_WIDTH > 768) {
//				FULL_SCREEN_WIDTH = 1024;
//				FULL_SCREEN_HEIGHT = 768;
//			} else {
//				FULL_SCREEN_WIDTH = 640;
//				FULL_SCREEN_HEIGHT = 480;
//			}
//			
//			W = SCREEN_WIDTH;
//			H = (int) (SCREEN_HEIGHT - (HEADER_HEIGHT * 2 * reductionRatio));
//			
//			frame = new Frame("Code ver2.0");
//			frame.setLayout(null);
//			
//			image = ImageIO.read(new File("./img/title_.gif"));
//			image = image.getScaledInstance(W, (int)(HEADER_HEIGHT*reductionRatio), Image.SCALE_SMOOTH);
//			ImageIcon icon = new ImageIcon(image);
//			titleLabel = new JLabel(icon);
//			titleLabel.setSize(icon.getIconWidth(), icon.getIconHeight());
//			if(FULL_SCREEN){
//				int w = (FULL_SCREEN_WIDTH - SCREEN_WIDTH) / 2;
//				int h = (FULL_SCREEN_HEIGHT - SCREEN_HEIGHT) / 2;
//				titleLabel.setLocation(w, h);
//			}else{
//				titleLabel.setLocation(0, 30);
//			}
//			
//			image = ImageIO.read(new File("./img/footer_.gif"));
//			image = image.getScaledInstance(W, (int)(HEADER_HEIGHT*reductionRatio), Image.SCALE_SMOOTH);
//			icon = new ImageIcon(image);
//			footerLabel = new JLabel(icon);
//			footerLabel.setSize(icon.getIconWidth(), icon.getIconHeight());
//			if(FULL_SCREEN){
//				int w = (FULL_SCREEN_WIDTH - SCREEN_WIDTH) / 2;
//				int h = (FULL_SCREEN_HEIGHT - SCREEN_HEIGHT) / 2 + icon.getIconHeight() + H;
//				footerLabel.setLocation(w, h);
//			}else{
//				footerLabel.setLocation(0, 30+H+icon.getIconHeight());
//			}
//			
//			if(FULL_SCREEN){
//				int w = (FULL_SCREEN_WIDTH - SCREEN_WIDTH) / 2;
//				int h = (FULL_SCREEN_HEIGHT - SCREEN_HEIGHT) / 2 + icon.getIconHeight();
//				applet.setLocation(w, h);
//			}else{
//				applet.setLocation(0, 30 + icon.getIconHeight());
//			}
//			
//			if(FULL_SCREEN)frame.setUndecorated(true);
//			frame.setBackground(Color.BLACK);
//			frame.add(titleLabel);
//			frame.add(applet);
//			frame.add(footerLabel);
//			
//			GraphicsDevice gd = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice();
//			if(FULL_SCREEN){
//				if (gd.isFullScreenSupported()) {
//					gd.setFullScreenWindow(frame);
//				}
//				if (gd.isDisplayChangeSupported()) {
//					gd.setDisplayMode(new DisplayMode(FULL_SCREEN_WIDTH, FULL_SCREEN_HEIGHT, 32, 0));
//				}
//			}else{
//				DisplayMode mode = gd.getDisplayMode();
//				int localeX = mode.getWidth() / 2 - W / 2;
//				int localeY = 0;//mode.getHeight() / 2 - H / 2;
//				frame.setBounds(localeX, localeY, SCREEN_WIDTH, SCREEN_HEIGHT+40);
//			}
//			
//			frame.setVisible(true);
//			applet.requestFocus();
//			
//			frame.addWindowListener(new WindowAdapter() {
//				public void windowClosing(WindowEvent e) {
//					
//					// OpenGLgĂƕʂɗƂƂ܂Ȃ
//					System.out.println("System down");
//					Synth.stop();
//					Synth.stopEngine();
//					System.exit(1);
//					
//				}
//			});
//		} catch (Exception e) {
//			e.printStackTrace();
//			System.exit(1);
//		}
//	}
	
//	public static JLabel titleLabel, footerLabel;
//	public static Image image;


}
